from .movechecker import MoveChecker
from .gravitator import Gravitator
from .triosremover import TriosRemover

class BrutalForcer():
    def __init__(self, grid):
        self.__grid = grid
        self.__score = 0
        self.__gravitator = Gravitator(self.__grid)
        self.__remover = TriosRemover()
        self.__mc = MoveChecker(grid)

    def do_it(self):
        result = False
        running = True
        step = 1

        while running:
            print(step)
            step += 1
            result = False
            for y in range(0, 8):
                for x in range(0, 8):
                    if x > 0:
                        result = result or self.__mc.check_move(x - 1, y, x, y)
                    if y > 0:
                        result = result or self.__mc.check_move(x, y - 1, x, y)

                    if x < 7:
                        result = result or self.__mc.check_move(x + 1, y, x, y)
                    if y < 7:
                        result = result or self.__mc.check_move(x + 1, y, x, y)
                    print(result, x, y)
            if result:
                number_of_removed = self.__remover.remove_trios(self.__grid)
                while number_of_removed:
                    self.__score += number_of_removed * 3
                    self.__gravitator.apply_gravity()
                    self.update()
                    number_of_removed = self.__remover.remove_trios(self.__grid)
            else:
                print("konec")
                running = False

        print("skore", self.__score)