from enum import Enum

class TrioDirection(Enum):
    Horizontal = "h"
    Vertical = "v"


class TrioFinder:
    def find_trios(self, grid):
        """
        :type grid: dict
        :return:
        """

        # first find horizontal trios
        trios = list()

        for y, row in grid.items():
            for x in range(0, len(row.values()) - 2):
                if self.check_trio(list(row.values())[x:x+3]):
                    trios.append((x, y, TrioDirection.Horizontal))

        for x in range(0, len(grid[0])):
            # create columns
            column = list()

            for y in range(0, len(grid)):
                column.append(grid[y][x])

            # check trios
            for y in range(0, len(column) - 2):
                if self.check_trio(list(column)[y:y+3]):
                    trios.append((x, y, TrioDirection.Vertical))


        return trios

    def check_trio(self, trio):
        """
        :param trio: list
        :return: bool
        """

        assert len(trio) == 3

        if len(set(trio)) == 1 and not (None in set(trio)):
            return True
        return False