from PyQt5.QtWidgets import QWidget, QSpinBox, QPushButton, QVBoxLayout, QHBoxLayout
from PyQt5.QtCore import QObject, pyqtSignal

class TimePicker(QWidget):
    start_normal = pyqtSignal()
    start_with_time = pyqtSignal(int)

    def __init__(self):
        super().__init__()

        self.__minutes_spinbox = QSpinBox(self)
        self.__minutes_spinbox.setMinimum(0)
        self.__minutes_spinbox.setValue(1)
        self.__seconds_spinbox = QSpinBox(self)
        self.__seconds_spinbox.setRange(0, 59)
        self.__minutes_spinbox.setValue(0)

        self.__start_with_time_button = QPushButton("Start with timer", self)
        self.__start_normal_button = QPushButton("Start", self)

        time_layout = QHBoxLayout()
        time_layout.addWidget(self.__minutes_spinbox)
        time_layout.addWidget(self.__seconds_spinbox)

        button_layout = QHBoxLayout()
        button_layout.addWidget(self.__start_with_time_button)
        button_layout.addWidget(self.__start_normal_button)

        layout = QVBoxLayout()
        layout.addLayout(time_layout)
        layout.addLayout(button_layout)

        self.setLayout(layout)

        self.__start_normal_button.clicked.connect(self.start_normal.emit)
        self.__start_with_time_button.clicked.connect(self.__emit_game_with_timer)

    def __emit_game_with_timer(self):
        seconds = self.__minutes_spinbox.value() * 60 + self.__seconds_spinbox.value()
        self.start_with_time.emit(seconds)